#region Using

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;

using Wisej.Web;
#endregion

namespace Wisej.EnterKeySample
{
    public partial class DAContainerControl: DABaseUserControl//, IDAContainer
    {
        public EventHandler PrintClicked;
        public EventHandler HelpClicked;
         
        bool _daControlTitleVisible;
        string _daControlTitle;
        bool _daPrintVisible = false;
        bool _daHelpVisible = false;
        bool _daIsTopControl = false;
        bool _daControlHeaderVisible = false;
        bool _daControlSubHeaderVisible = false;
        bool _daControlFooterVisible = false;
        bool _daControlHasBorder = false;
        int _controlHeaderHeight = 24;
        int _topControlHeaderHeight = 28;

        #region Properties
        [
        DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)
        ]
        public bool DAControlTitleVisible
        {
            get
            {
                return _daControlTitleVisible;
            }
            set
            {
                this.DAControlHeaderVisible = value;
                pnlControlHeader.Visible = value;
                _daControlTitleVisible = value;                    
            }
        }

        [
        DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)
        ]
        public string DAControlTitle
        {
            get
            {
                return _daControlTitle;
            }
            set
            {
                _daControlTitle = value;
                lblControlTitle.Text = value;
            }
        }

        [
        DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)
        ]
        public Font DAControlTitleFont
        {
            set
            {
                lblControlTitle.Font = value;
            }
        }

        [
        DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)
        ]
        public Color DAControlTitleForeColor
        {
            set
            {
                lblControlTitle.ForeColor = value;
            }
        }
        [
        DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)
        ]
        public bool DAPrintVisible
        {
            get
            {
                return _daPrintVisible;
            }
            set
            {
                _daPrintVisible = value;
                btnPrint.Visible = value;
                ToolTip t = new ToolTip();
                t.SetToolTip(btnPrint, "Print");
                flpButtons.Controls.Add(btnPrint);
            }
        }

        [
        DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)
        ]
        public bool DAHelpVisible
        {
            get
            {
                return _daHelpVisible;
            }
            set
            {
                _daHelpVisible = value;
                btnHelp.Visible = value;
                ToolTip t = new ToolTip();
                t.SetToolTip(btnHelp, "Help");
                flpButtons.Controls.Add(btnHelp);
            }
        }

        [
        DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)
        ]
        public bool DAIsTopControl
        {
            get
            {
                return _daIsTopControl;
            }
            set
            {
                _daIsTopControl = value;
            }
        }

        [
        DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)
        ]
        public bool DAControlHeaderVisible
        {
            get
            {
                return _daControlHeaderVisible;
            }
            set
            {
                _daControlHeaderVisible = value;
                pnlControlHeader.Visible = value;
                if (_daControlHeaderVisible)
                {
                    pnlControlHeader.Height = (_daIsTopControl ? _topControlHeaderHeight : _controlHeaderHeight);
                }
            }
        }

        [
        DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)
        ]
        public bool DAControlSubHeaderVisible
        {
            get
            {
                return _daControlSubHeaderVisible;
            }
            set
            {
                _daControlSubHeaderVisible = value;
                pnlControlSubHeader.Visible = value;
            }
        }

        [
        DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)
        ]
        public bool DAControlFooterVisible
        {
            get
            {
                return _daControlFooterVisible;
            }
            set
            {
                _daControlFooterVisible = value;
                pnlControlFooter.Visible = value;
            }
        }

        [
        DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)
        ]
        public bool DAControlHasBorder
        {
            get
            {
                return _daControlHasBorder;
            }
            set
            {
                _daControlHasBorder = value;
                pnlBorderLeft.Visible = value;
                pnlBorderRight.Visible = value;
                pnlBorderTop.Visible = value;
                pnlBorderBottom.Visible = value;
            }
        }


        //public DAConnection DAConnection { get; set; }

        public object DAAncestorContainerToInform { get; set; }

        #endregion

        #region IDAContainer implementation
        public bool ContentHasChanges { get; set; }
        public Panel ContainerPanel
        {
            get { return pnlControlBody; }
        }
        //public List<IDAContent> DAContentControls { get; set; }
        #endregion

        public DAContainerControl()
        {
            InitializeComponent();
        }

        //public DAContainerControl(string connectionString, string fileConnectionString)
        //{
        //    InitializeComponent();

        //    this.DAConnection = new DAConnection();
        //    this.DAConnection.DAConnectionString = connectionString;
        //    this.DAConnection.DAFileConnectionString = fileConnectionString;
        //}

        #region Methods

        public void ArrangeContainer()
        {
            lblEmptyMessage.Dock = DockStyle.Fill;

            //this.btnHelp.BackgroundImage = new Gizmox.WebGUI.Common.Resources.ImageResourceHandle("Info.png");
            this.btnHelp.BackgroundImageLayout = Wisej.Web.ImageLayout.Stretch;

            //this.btnPrint.BackgroundImage = new Gizmox.WebGUI.Common.Resources.ImageResourceHandle("PrintPreview.png");
            this.btnPrint.BackgroundImageLayout = Wisej.Web.ImageLayout.Stretch;

            pnlControlHeader.Visible = _daControlHeaderVisible;
            pnlControlSubHeader.Visible = _daControlSubHeaderVisible;
            pnlControlFooter.Visible = _daControlFooterVisible;
            pnlBorderLeft.Visible = _daControlHasBorder;
            pnlBorderRight.Visible = _daControlHasBorder;
            pnlBorderTop.Visible = _daControlHasBorder;
            pnlBorderBottom.Visible = _daControlHasBorder;

            if (_daIsTopControl)
            {
                lblControlTitle.Font = new System.Drawing.Font("Tahoma", (float)11.00, System.Drawing.FontStyle.Bold);
                lblControlTitle.ForeColor = System.Drawing.Color.White;
                //pnlControlHeader.BackgroundImage = new Gizmox.WebGUI.Common.Resources.ImageResourceHandle("TopGreen.JPG"); 
                pnlControlHeader.BackgroundImageLayout = ImageLayout.Tile;
            }
            else
            {
                lblControlTitle.Font = new System.Drawing.Font("Tahoma", (float)10.00, System.Drawing.FontStyle.Regular);
                lblControlTitle.ForeColor = System.Drawing.Color.Black;
                //pnlControlHeader.BackgroundImage = new Gizmox.WebGUI.Common.Resources.ImageResourceHandle("NonTopGreen.JPG"); //Properties.Resources.NonTopGreen;
                pnlControlHeader.BackgroundImageLayout = ImageLayout.Tile;
            }

            pnlControlBody.Dock = DockStyle.Fill;
        }

        //public virtual void DAPrint(object sender, EventArgs e)
        //{
        //    LinkParameters linkParms = new LinkParameters();

        //    linkParms.ShowToolBar = false;
        //    linkParms.ShowLocationBar = false;
        //    linkParms.ShowMenuBar = false;
        //    linkParms.ShowStatusBar = false;
        //    linkParms.ShowTitleBar = false;
        //    linkParms.Resizable = false;
        //    linkParms.Target = "_new";
        //    linkParms.Size = new Size(10, 10);
        //    linkParms.Location = new Point(-100, -100);
        //    Wisej.Web.Link.Open("PrintForm." + "", linkParms);

        //}
        #endregion

        #region Events
        private void btnPrint_Click(object sender, EventArgs e)
        {
            if (PrintClicked != null)
            {
                PrintClicked(sender, e);
            }
        }

        private void btnHelp_Click(object sender, EventArgs e)
        {
            if (HelpClicked != null)
            {
                HelpClicked(sender, e);
            }
        }


        #endregion

    }    

}